From 17d8190306cd0d0b0353bd7912aba8d9e748abd9 Mon Sep 17 00:00:00 2001
From: Peter Smith <peter.b.smith@fujitsu.com>
Date: Thu, 13 Nov 2025 16:10:25 +1100
Subject: [PATCH v1] Fix more <structfield> tags

---
 doc/src/sgml/func/func-sequence.sgml  | 8 ++++----
 doc/src/sgml/ref/alter_sequence.sgml  | 4 ++--
 doc/src/sgml/ref/create_sequence.sgml | 6 +++---
 3 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/doc/src/sgml/func/func-sequence.sgml b/doc/src/sgml/func/func-sequence.sgml
index e8d42b2..4a2a6dc 100644
--- a/doc/src/sgml/func/func-sequence.sgml
+++ b/doc/src/sgml/func/func-sequence.sgml
@@ -67,14 +67,14 @@
        </para>
        <para>
         Sets the sequence object's current value, and optionally
-        its <literal>is_called</literal> flag.  The two-parameter
-        form sets the sequence's <literal>last_value</literal> field to the
-        specified value and sets its <literal>is_called</literal> field to
+        its <structfield>is_called</structfield> flag.  The two-parameter
+        form sets the sequence's <structfield>last_value</structfield> field to the
+        specified value and sets its <structfield>is_called</structfield> field to
         <literal>true</literal>, meaning that the next
         <function>nextval</function> will advance the sequence before
         returning a value.  The value that will be reported
         by <function>currval</function> is also set to the specified value.
-        In the three-parameter form, <literal>is_called</literal> can be set
+        In the three-parameter form, <structfield>is_called</structfield> can be set
         to either <literal>true</literal>
         or <literal>false</literal>.  <literal>true</literal> has the same
         effect as the two-parameter form. If it is set
diff --git a/doc/src/sgml/ref/alter_sequence.sgml b/doc/src/sgml/ref/alter_sequence.sgml
index a998ccc..db7b98f 100644
--- a/doc/src/sgml/ref/alter_sequence.sgml
+++ b/doc/src/sgml/ref/alter_sequence.sgml
@@ -207,8 +207,8 @@ ALTER SEQUENCE [ IF EXISTS ] <replaceable class="parameter">name</replaceable> S
         The optional clause <literal>RESTART [ WITH <replaceable
         class="parameter">restart</replaceable> ]</literal> changes the
         current value of the sequence.  This is similar to calling the
-        <function>setval</function> function with <literal>is_called</literal> =
-        <literal>false</literal>: the specified value will be returned by the
+        <function>setval</function> function with <structfield>is_called</structfield>
+        = <literal>false</literal>: the specified value will be returned by the
         <emphasis>next</emphasis> call of <function>nextval</function>.
         Writing <literal>RESTART</literal> with no <replaceable
         class="parameter">restart</replaceable> value is equivalent to supplying
diff --git a/doc/src/sgml/ref/create_sequence.sgml b/doc/src/sgml/ref/create_sequence.sgml
index 1e283f1..0ffcd0f 100644
--- a/doc/src/sgml/ref/create_sequence.sgml
+++ b/doc/src/sgml/ref/create_sequence.sgml
@@ -70,7 +70,7 @@ SELECT * FROM <replaceable>name</replaceable>;
 </programlisting>
 
    to examine the parameters and current state of a sequence.  In particular,
-   the <literal>last_value</literal> field of the sequence shows the last value
+   the <structfield>last_value</structfield> field of the sequence shows the last value
    allocated by any session.  (Of course, this value might be obsolete
    by the time it's printed, if other sessions are actively doing
    <function>nextval</function> calls.)
@@ -295,7 +295,7 @@ SELECT * FROM <replaceable>name</replaceable>;
    used for a sequence object that will be used concurrently by
    multiple sessions.  Each session will allocate and cache successive
    sequence values during one access to the sequence object and
-   increase the sequence object's <literal>last_value</literal> accordingly.
+   increase the sequence object's <structfield>last_value</structfield> accordingly.
    Then, the next <replaceable class="parameter">cache</replaceable>-1
    uses of <function>nextval</function> within that session simply return the
    preallocated values without touching the sequence object.  So, any
@@ -319,7 +319,7 @@ SELECT * FROM <replaceable>name</replaceable>;
    class="parameter">cache</replaceable> setting greater than one you
    should only assume that the <function>nextval</function> values are all
    distinct, not that they are generated purely sequentially.  Also,
-   <literal>last_value</literal> will reflect the latest value reserved by
+   <structfield>last_value</structfield> will reflect the latest value reserved by
    any session, whether or not it has yet been returned by
    <function>nextval</function>.
   </para>
-- 
1.8.3.1